﻿///////////////////////////////////////////////////////////////////////////////
//
// (C) 2017 ICE TEA GROUP LLC - ALL RIGHTS RESERVED
//
// ALL INFORMATION CONTAINED HEREIN IS, AND REMAINS
// THE PROPERTY OF ICE TEA GROUP LLC AND ITS SUPPLIERS, IF ANY.
// THE INTELLECTUAL PROPERTY AND TECHNICAL CONCEPTS CONTAINED
// HEREIN ARE PROPRIETARY TO ICE TEA GROUP LLC AND ITS SUPPLIERS
// AND MAY BE COVERED BY U.S. AND FOREIGN PATENTS, PATENT IN PROCESS, AND
// ARE PROTECTED BY TRADE SECRET OR COPYRIGHT LAW.
//
// DISSEMINATION OF THIS INFORMATION OR REPRODUCTION OF THIS MATERIAL
// IS STRICTLY FORBIDDEN UNLESS PRIOR WRITTEN PERMISSION IS OBTAINED
// FROM ICE TEA GROUP LLC.
//
///////////////////////////////////////////////////////////////////////////////

/**
 * wisej.web.ext.CountUp
 */
qx.Class.define("wisej.web.ext.Uploader", {

	extend: wisej.web.Button,

	properties: {
        
	},

	construct: function () {

        this.base(arguments);
        this.options = {};
        this.addListenerOnce("appear", this.__onAppear, this);
	},

	members: {

		/**
		 * Creates the CountUp widget the first time the DOM element is created.
		 */
		__onAppear: function (e) {
			this.__createUploaderElement();
        },

		/**
		 * Creates the CountUp widgets inside our widget container.
		 */
		__createUploaderElement: function () {
            var me = this;
            var dom = this.getContentElement().getDomElement();

            this.resumable = new Resumable({
                target: '/ChunkUpload.axd',
                query: { upload_token: 'my_token' }
            });

            this.resumable.on('fileAdded', function (fileInfo, event) {
                var file = fileInfo.file;
                me.UploadFileChanged(fileInfo.uniqueIdentifier, file.name, file.size, file.type);
            });

            this.resumable.on('fileSuccess', function (file, message) {
                me.UploadFileSuccess();
            });

            this.resumable.on('fileError', function (file, message) {
                me.UploadFileError(message);
            });

            this.resumable.on('fileProgress', function (file) {
                me.UpdateFileState(file.progress());
            });

            this.resumable.assignBrowse(dom);            
        },

        cancelDownload: function () {
            this.resumable.cancel();
        },

        startUpload: function () {
            this.resumable.upload();
        },
	},
});
